with Messages, Lattice, Lattice.Ops, Lattice.IO;
use Messages, Lattice, Lattice.Ops, Lattice.IO;

procedure ShowEntropies is      -- compute and show polymer entropies

  LP: constant Positive :=  3;  -- layer period: set 2 for AB, 3 for ABC
  NP: constant Positive :=  5;  -- size of polymers

  N1: constant Positive := 12;  -- lattice patch depth:  -N1 .. N1
  N2: constant Positive := 12;  -- lattice patch width:  -N2 .. N1
  N3: constant Positive :=  8;  -- lattice patch height: -N3 .. N3

  E: PExpPtr;

begin
  Verbose := 1;

  InitPatch(N1,N2,N3,LP);
  E := Entropies(NP);           -- compute entropies
  for N in 1 .. NP loop
    Show(E(N),E(N)'Last,99);
  end loop;

end ShowEntropies;
