
package body Volumes is

  function BasicVol return Rep is
  begin
    return Log(Three);
  end BasicVol;

  function StoredVols(PType,PSize: in Positive) return PolysPtr is
  begin
    GPolys := new Polys(1 .. MaxNumPolymers);
    GType := PType;
    GSize := 0;
    CPoly := null;
    CLast := PSize;
    if PType=2 then
      if    PSize=1 then VolumesHCP1;
      elsif PSize=2 then VolumesHCP2;
      elsif PSize=3 then VolumesHCP3;
      elsif PSize=4 then VolumesHCP4;
      elsif PSize=5 then VolumesHCP5;
      else
        Message("Volumes.StoredVols",Not_Implemented);
      end if;
    elsif PType=3 then
      if    PSize=1 then VolumesFCC1;
      elsif PSize=2 then VolumesFCC2;
      elsif PSize=3 then VolumesFCC3;
      elsif PSize=4 then VolumesFCC4;
      elsif PSize=5 then VolumesFCC5;
      else
        Message("Volumes.StoredVols",Not_Implemented);
      end if;
    else
      Message("Volumes.StoredVols",Not_Implemented);
    end if;
    Store_Last_Polymer;
    SortPolyPtr(GPolys.all,1,GSize);
    Trim(GPolys,GSize);
    return GPolys;
  end StoredVols;

  function StoredVols(PType,MaxSize: in Positive) return PExpPtr is
    E: PExpPtr := new PExp(1 .. MaxSize);
  begin
    for PSize in 1 .. MaxSize loop
      E(PSize) := StoredVols(PType,PSize);
    end loop;
    return E;
  end StoredVols;

  procedure Store_Last_Polymer is
  begin
    if CPoly=null then return; end if;
    if CPoly.L /= CPoly.V'Last then
      Message("Volumes.Store_Last_Polymer",Data_Problem);
    end if;
    GSize := GSize+1;
    GPolys(GSize) := CPoly;
    CPoly := null;
  end Store_Last_Polymer;

  procedure New_Polymer(T: in Positive) is
  begin
    Store_Last_Polymer;
    if T /= GType then
      Message("Volumes.New_Polymer",Data_Problem);
    end if;
    CPoly := new Poly(CLast);
  end New_Polymer;

  procedure Add_Ball(P1,P2,P3: in Integer) is
  begin
    CPoly.L := CPoly.L+1;
    Pack(Pt(P1,P2,P3),1,CPoly.V(CPoly.L));
  end Add_Ball;

  procedure Add_Multiplicity(M: in Natural) is
  begin
    CPoly.M := M;
  end Add_Multiplicity;

  procedure Add_Value(R: in Rep) is
  begin
    CPoly.R := Log(R);
  end Add_Value;

  pragma Inline (New_Polymer,Add_Ball,Add_Multiplicity,Add_Value);

  procedure VolumesFCC1 is
  begin
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Multiplicity(1);
    Add_Value( 3.00000000000000000E+000);
  end VolumesFCC1;

  procedure VolumesHCP1 is
  begin
    New_Polymer(2);
    Add_Ball(0,0,0);
    Add_Multiplicity(1);
    Add_Value( 3.00000000000000000E+000);
  end VolumesHCP1;

  procedure VolumesFCC2 is
  begin
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Multiplicity(6);
    Add_Value( 8.75625000000000000E+000);
  end VolumesFCC2;

  procedure VolumesHCP2 is
  begin
    New_Polymer(2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 8.75944251543209876E+000);
    New_Polymer(2);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 8.75625000000000000E+000);
  end VolumesHCP2;

  procedure VolumesFCC3 is
  begin
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(0,1,-1);
    Add_Multiplicity(12);
    Add_Value( 2.55715680803571429E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(1,-2,0);
    Add_Multiplicity(8);
    Add_Value( 2.50688502720424107E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Multiplicity(6);
    Add_Value( 2.53319196428571429E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Multiplicity(24);
    Add_Value( 2.54822172619047619E+001);
  end VolumesFCC3;

  procedure VolumesHCP3 is
  begin
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.55382358257802007E+001);
    New_Polymer(2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.55808800907323141E+001);
    New_Polymer(2);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.54822172619047619E+001);
    New_Polymer(2);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.50871011755944405E+001);
    New_Polymer(2);
    Add_Ball(-1,2,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(1);
    Add_Value( 2.53049001219411376E+001);
    New_Polymer(2);
    Add_Ball(-1,2,0);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(1);
    Add_Value( 2.48441318411044975E+001);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.54022606722369402E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.54929823664600165E+001);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.53319196428571428E+001);
  end VolumesHCP3;

  procedure VolumesFCC4 is
  begin
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(12);
    Add_Value( 7.16830569273312733E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(2,0,-1);
    Add_Multiplicity(3);
    Add_Value( 7.27359045172356940E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Multiplicity(12);
    Add_Value( 7.15578275755679969E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(3,-3,0);
    Add_Multiplicity(24);
    Add_Value( 7.41249912304898877E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(2);
    Add_Value( 7.10297476743722891E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-2,2,-1);
    Add_Ball(0,1,-1);
    Add_Multiplicity(12);
    Add_Value( 7.46783221673346185E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(0,1,-1);
    Add_Multiplicity(24);
    Add_Value( 7.39824037388392857E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(2,0,-1);
    Add_Multiplicity(12);
    Add_Value( 7.40321609933035714E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(6,-3,0);
    Add_Multiplicity(6);
    Add_Value( 7.31570166015625000E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,1,-1);
    Add_Multiplicity(24);
    Add_Value( 7.41249912304898877E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(24);
    Add_Value( 7.42142583885027733E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-3,0);
    Add_Multiplicity(8);
    Add_Value( 7.39560842380275974E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(48);
    Add_Value( 7.30213940318012650E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 7.44189241642146915E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Multiplicity(48);
    Add_Value( 7.23527237981325620E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(24);
    Add_Value( 7.27638234794913948E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-3,1,-1);
    Add_Multiplicity(48);
    Add_Value( 7.44189241642146916E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-4,0,-1);
    Add_Multiplicity(24);
    Add_Value( 7.41249912304898877E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Multiplicity(24);
    Add_Value( 7.41249912304898877E+001);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(5,-1,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Multiplicity(48);
    Add_Value( 7.36493474681243236E+001);
  end VolumesFCC4;

  procedure VolumesHCP4 is
  begin
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.46303053942884291E+001);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 7.18149684642414395E+001);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.41301266997236036E+001);
    New_Polymer(2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.30747510320651039E+001);
    New_Polymer(2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.24100727864867213E+001);
    New_Polymer(2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 7.27888497954921173E+001);
    New_Polymer(2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.17643798192325584E+001);
    New_Polymer(2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.40593939615949750E+001);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.35730950170976182E+001);
    New_Polymer(2);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 7.15880374969713835E+001);
    New_Polymer(2);
    Add_Ball(0,3,0);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(2);
    Add_Value( 7.39560842380275974E+001);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.44778505341891801E+001);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.41872525848289632E+001);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.38718441376557821E+001);
    New_Polymer(2);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(2);
    Add_Value( 7.05704395862125217E+001);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 7.44421715309959862E+001);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.40193394409221531E+001);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.43030453868056920E+001);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.45817099367441505E+001);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.26813619530586633E+001);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.47327047855255789E+001);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.28347217327350767E+001);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.41872525848289632E+001);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.23001915198860023E+001);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.25817090773729605E+001);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.39775264059859119E+001);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.40107267901590188E+001);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.44464766475948498E+001);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.47055135761681398E+001);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.41572483855232976E+001);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.44503485159504279E+001);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.36484670716653138E+001);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.41249574673915494E+001);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.36502278645833333E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.44463610821065588E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.44503485159504279E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.23783091285215372E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.30787553742126182E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.24079206516856383E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.28202730568005532E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.16390575819113517E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.42457943167435572E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,4,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.41885566202163580E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-3,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.44778505341891801E+001);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.35038211656327495E+001);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.35730950170976182E+001);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(0,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 7.41259674768048791E+001);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.30475582611979401E+001);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.16974834549662129E+001);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(-3,3,0);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 7.41240825103715728E+001);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.38718441376557821E+001);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.41885566202163580E+001);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.36811564710618514E+001);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.41612293561742502E+001);
    New_Polymer(2);
    Add_Ball(-3,6,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 7.31570166015625000E+001);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 7.41562891695105526E+001);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 7.41612293561742503E+001);
  end VolumesHCP4;

  procedure VolumesFCC5 is
  begin
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-1,3,-1);
    Add_Ball(0,1,-1);
    Add_Ball(2,0,-1);
    Add_Ball(-1,1,-2);
    Add_Multiplicity(6);
    Add_Value( 2.15608254347842448E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(2,0,-1);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(6);
    Add_Value( 2.00506323977668432E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(-2,3,-2);
    Add_Ball(0,2,-2);
    Add_Multiplicity(12);
    Add_Value( 2.16067098947805125E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-3,0);
    Add_Ball(2,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.16476967571930894E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.02642520565649449E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(3,-3,0);
    Add_Multiplicity(24);
    Add_Value( 2.02674695444209680E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(3,-3,0);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.12611316695678218E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15088422437613133E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(24);
    Add_Value( 2.10111569399857157E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(2,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15245334934474705E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(3,-3,0);
    Add_Multiplicity(48);
    Add_Value( 2.10273205734354491E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(4,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15095500053332084E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(5,-3,-1);
    Add_Multiplicity(24);
    Add_Value( 2.14103543090617065E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(5,-4,0);
    Add_Multiplicity(24);
    Add_Value( 2.14103543090617065E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(6,-3,0);
    Add_Multiplicity(48);
    Add_Value( 2.12654149050514102E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(0,1,-1);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(12);
    Add_Value( 2.08785126351696214E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(-2,2,-1);
    Add_Ball(0,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.13252290955771204E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,3,-1);
    Add_Ball(0,1,-1);
    Add_Ball(-1,1,-2);
    Add_Multiplicity(24);
    Add_Value( 2.16740547411543767E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,3,-1);
    Add_Ball(0,1,-1);
    Add_Ball(-2,3,-2);
    Add_Multiplicity(24);
    Add_Value( 2.17334924710396734E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-2,2,-1);
    Add_Ball(0,1,-1);
    Add_Ball(0,2,-2);
    Add_Multiplicity(24);
    Add_Value( 2.16211328620598152E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-2,2,-1);
    Add_Ball(0,1,-1);
    Add_Ball(-2,3,-2);
    Add_Multiplicity(12);
    Add_Value( 2.18087996262861894E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(0,1,-1);
    Add_Ball(0,2,-2);
    Add_Multiplicity(12);
    Add_Value( 2.14035613221007508E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(0,1,-1);
    Add_Ball(2,0,-1);
    Add_Multiplicity(24);
    Add_Value( 2.10586282685606630E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(0,1,-1);
    Add_Ball(4,-1,-1);
    Add_Multiplicity(12);
    Add_Value( 2.16067098947805124E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(1,-2,0);
    Add_Ball(2,-4,0);
    Add_Multiplicity(24);
    Add_Value( 2.08788305465560460E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(2,0,-1);
    Add_Ball(2,1,-2);
    Add_Multiplicity(12);
    Add_Value( 2.14197968432934253E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(-2,2,-1);
    Add_Ball(0,1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.16055602149446187E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(6,-3,0);
    Add_Ball(0,1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.13658214486624216E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(6,-3,0);
    Add_Ball(2,0,-1);
    Add_Multiplicity(24);
    Add_Value( 2.13815535153323239E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(6,-3,0);
    Add_Ball(8,-4,0);
    Add_Multiplicity(6);
    Add_Value( 2.11202301548549107E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-2,2,-1);
    Add_Ball(0,1,-1);
    Add_Ball(2,0,-1);
    Add_Ball(0,2,-2);
    Add_Multiplicity(3);
    Add_Value( 2.14529363839285714E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15886646146829187E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(0,2,-2);
    Add_Multiplicity(48);
    Add_Value( 2.14212548221272194E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.08364495712586697E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(1,0,-2);
    Add_Multiplicity(24);
    Add_Value( 2.15608694320399246E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.12423966684314600E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(-1,1,-2);
    Add_Multiplicity(48);
    Add_Value( 2.15608694320399246E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(2,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.16476967571930894E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,1,-1);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.11574175933221261E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-2,-1);
    Add_Ball(-1,-2,-2);
    Add_Multiplicity(48);
    Add_Value( 2.15886646146829187E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-2,-1);
    Add_Ball(-1,-3,-1);
    Add_Multiplicity(48);
    Add_Value( 2.16735994760320130E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-2,-1);
    Add_Ball(1,-3,-2);
    Add_Multiplicity(48);
    Add_Value( 2.14508118671591267E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-2,-1);
    Add_Ball(1,-4,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15886646146829187E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-3,0);
    Add_Ball(0,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15033769017888036E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-3,0);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.11424112576593676E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-3,0);
    Add_Ball(1,-5,0);
    Add_Multiplicity(24);
    Add_Value( 2.13530936684339656E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-3,0);
    Add_Ball(-3,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15986743401879231E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-1,0,-1);
    Add_Ball(0,-1,-2);
    Add_Multiplicity(48);
    Add_Value( 2.11958173816412640E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-1,0,-1);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(24);
    Add_Value( 2.08277042795980981E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-1,0,-1);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.08799102620745466E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-1,0,-1);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.04145824628243565E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-1,-1);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(24);
    Add_Value( 2.11101717682950725E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-1,-1);
    Add_Ball(1,0,-2);
    Add_Multiplicity(24);
    Add_Value( 2.16575034860917194E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-1,-1);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.12504305328844662E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-1,-1);
    Add_Ball(2,-2,-2);
    Add_Multiplicity(48);
    Add_Value( 2.15303330907090782E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-1,-1);
    Add_Ball(3,-2,-1);
    Add_Multiplicity(24);
    Add_Value( 2.16575034860917194E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(0,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.09937988515216803E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(24);
    Add_Value( 2.06439985275886932E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(0,-3,0);
    Add_Multiplicity(24);
    Add_Value( 2.06089016873340166E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.07087695033385625E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.06893493716816239E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.06171361008394485E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(-2,-2,0);
    Add_Multiplicity(12);
    Add_Value( 2.05054732581506565E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(2,-3,-1);
    Add_Multiplicity(48);
    Add_Value( 2.09811823359188696E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(2,-4,0);
    Add_Multiplicity(48);
    Add_Value( 2.08636767484948068E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(-3,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.11310509346127646E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(3,-3,0);
    Add_Multiplicity(24);
    Add_Value( 2.08465127202733249E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Ball(-4,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.10273205734354491E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-1,3,-1);
    Add_Ball(0,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15608694320399246E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(2,0,-1);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.17330431403193713E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-1,-1);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(48);
    Add_Value( 2.07952891657017148E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-1,-1);
    Add_Ball(-2,0,-2);
    Add_Multiplicity(24);
    Add_Value( 2.11115793911103018E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-2,0);
    Add_Ball(0,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.10273205734354491E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-2,0);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(48);
    Add_Value( 2.10953461688243780E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-2,0);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(24);
    Add_Value( 2.06915460318635617E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-2,0);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.11310509346127646E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-2,0);
    Add_Ball(-1,-3,-1);
    Add_Multiplicity(48);
    Add_Value( 2.10755669555123832E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-2,0);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.04579039719585394E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-2,0);
    Add_Ball(-3,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.10776650912232792E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-2,0);
    Add_Ball(-3,-2,-1);
    Add_Multiplicity(48);
    Add_Value( 2.10554840481398292E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-2,0);
    Add_Ball(-4,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.10657548603682141E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,2,-1);
    Add_Ball(0,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.16476967571930894E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,2,-1);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.12695565779216926E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,2,-1);
    Add_Ball(-3,1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.16575034860917194E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-3,1,-1);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(24);
    Add_Value( 2.16740547411543767E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-3,1,-1);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(24);
    Add_Value( 2.07182758604233557E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-3,1,-1);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.17334924710396734E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-3,1,-1);
    Add_Ball(-2,0,-2);
    Add_Multiplicity(24);
    Add_Value( 2.16575034860917194E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-3,1,-1);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.08060750840122150E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-3,1,-1);
    Add_Ball(-3,2,-2);
    Add_Multiplicity(48);
    Add_Value( 2.15303330907090782E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-3,1,-1);
    Add_Ball(-4,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.12423966684314600E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-3,1,-1);
    Add_Ball(-4,1,-2);
    Add_Multiplicity(48);
    Add_Value( 2.16575034860917194E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-4,0,-1);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15785390009075107E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-4,0,-1);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.07550259184717851E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-4,0,-1);
    Add_Ball(-3,-1,-2);
    Add_Multiplicity(48);
    Add_Value( 2.15608694320399246E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-4,0,-1);
    Add_Ball(-5,0,-2);
    Add_Multiplicity(48);
    Add_Value( 2.14212548221272194E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-4,0,-1);
    Add_Ball(-5,-1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.15608694320399246E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-4,3,-1);
    Add_Ball(-3,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.16575034860917194E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-5,2,-1);
    Add_Ball(-3,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.17330431403193713E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-5,2,-1);
    Add_Ball(-4,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.16476967571930894E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(1,-2,0);
    Add_Ball(-1,0,-1);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(24);
    Add_Value( 2.17334924710396734E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(1,-2,0);
    Add_Ball(-2,-1,-1);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(48);
    Add_Value( 2.16476967571930894E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(1,-2,0);
    Add_Ball(-2,-2,0);
    Add_Ball(0,-3,0);
    Add_Multiplicity(24);
    Add_Value( 2.15608694320399246E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,0,-1);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.16476967571930894E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15785390009075107E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-2,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15886646146829187E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(0,-3,0);
    Add_Multiplicity(48);
    Add_Value( 2.15033769017888036E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.11855529471492190E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.12423966684314600E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(1,-2,0);
    Add_Multiplicity(48);
    Add_Value( 2.06287841024842123E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(2,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.16476967571930894E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.11574175933221261E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-2,-2,0);
    Add_Multiplicity(48);
    Add_Value( 2.10273205734354491E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-3,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.16476967571930894E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(3,-2,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15608694320399246E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(3,-3,0);
    Add_Multiplicity(48);
    Add_Value( 2.15608694320399246E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-4,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15608694320399246E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(4,-2,0);
    Add_Multiplicity(48);
    Add_Value( 2.14212548221272194E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-2,-2,0);
    Add_Ball(-1,0,-1);
    Add_Ball(-2,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.12423966684314600E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-3,1,-1);
    Add_Ball(-1,0,-1);
    Add_Ball(-3,2,-2);
    Add_Multiplicity(48);
    Add_Value( 2.15453958012551065E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-5,2,-1);
    Add_Ball(-3,1,-1);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15245334934474705E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-3,0,0);
    Add_Ball(-6,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-4,-1,0);
    Add_Multiplicity(24);
    Add_Value( 2.15608694320399246E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(5,-1,0);
    Add_Ball(2,-1,0);
    Add_Ball(-1,-1,0);
    Add_Ball(4,-2,0);
    Add_Multiplicity(24);
    Add_Value( 2.14103543090617065E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(5,-1,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(0,1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15095500053332084E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(5,-1,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(-1,0,-1);
    Add_Multiplicity(24);
    Add_Value( 2.14103543090617065E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(5,-1,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(4,-1,-1);
    Add_Multiplicity(48);
    Add_Value( 2.11075449617511226E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(5,-1,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(5,-3,-1);
    Add_Multiplicity(24);
    Add_Value( 2.14281167507041879E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(5,-1,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(6,-2,-1);
    Add_Multiplicity(48);
    Add_Value( 2.15088422437613133E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(5,-1,0);
    Add_Ball(2,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(6,-3,0);
    Add_Multiplicity(48);
    Add_Value( 2.08761519796742307E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(5,-1,0);
    Add_Ball(4,-2,0);
    Add_Ball(1,-2,0);
    Add_Ball(3,-3,0);
    Add_Multiplicity(48);
    Add_Value( 2.14212548221272194E+002);
    New_Polymer(3);
    Add_Ball(0,0,0);
    Add_Ball(-6,0,0);
    Add_Ball(-1,-1,0);
    Add_Ball(-4,-1,0);
    Add_Ball(-2,-2,0);
    Add_Multiplicity(24);
    Add_Value( 2.12814934414137295E+002);
  end VolumesFCC5;

  procedure VolumesHCP5 is
  begin
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.09400764031518179E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.06988668319389845E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.16247595190229201E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(1);
    Add_Value( 2.00523927678658562E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15940178637253129E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.17198277686803029E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15547143437128639E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.17197673516439512E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.10615355254324052E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.06844843236054410E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.08001843739385227E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.16095919286625432E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.13330486992615045E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14040878057637857E+002);
    New_Polymer(2);
    Add_Ball(0,0,2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15540366192041103E+002);
    New_Polymer(2);
    Add_Ball(0,0,4);
    Add_Ball(-1,1,3);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15673987508676829E+002);
    New_Polymer(2);
    Add_Ball(0,0,4);
    Add_Ball(-1,1,3);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.16989019910376158E+002);
    New_Polymer(2);
    Add_Ball(0,0,4);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14508592491278360E+002);
    New_Polymer(2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(2,-2,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.12769961062060563E+002);
    New_Polymer(2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.03242062407148222E+002);
    New_Polymer(2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.02704277759119560E+002);
    New_Polymer(2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09227996181436298E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17077065211004472E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10067945060385151E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,1,3);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16173943459828661E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,1,3);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16173943459828573E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,1,3);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17400675209470599E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,1,3);
    Add_Ball(1,1,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14871322154736081E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10404024506361893E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,1,3);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15341862062335972E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17885100429952100E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10758721961518536E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10979975059092070E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08928069498968035E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14086663601227023E+002);
    New_Polymer(2);
    Add_Ball(0,2,3);
    Add_Ball(-3,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14270511540786230E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,0,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17289594555009272E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(0,-1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15992477570334338E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11712555350868609E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12669980301665072E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16575748714906012E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.10328614137408857E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10511592289317281E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.07629518728197554E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15418814289674103E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.08698926556732160E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14790353363323677E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16073855277178482E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16130323492166197E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17050091417372294E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10812922322849540E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13498380534225807E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11160858736692126E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.07864083679763117E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12266388859410188E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10991014761956371E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11825168301172396E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15743402591203769E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11309699965820220E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15036863520028029E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09749822346492183E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(1,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14957796909557157E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,4,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15818033297910627E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08554741390808864E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11271525996406372E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16994489205112265E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15136392680221909E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11553503893571210E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11977640734646869E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12748883604234759E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12712060722236118E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16133253503793075E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17050472643097685E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16651171671382327E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17501317951533854E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14634577174033749E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-2,1,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15289371726885711E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16913528489649633E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16054963024121333E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10858573901456703E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12162014507872703E+002);
    New_Polymer(2);
    Add_Ball(0,3,2);
    Add_Ball(-3,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15155485917520947E+002);
    New_Polymer(2);
    Add_Ball(0,3,4);
    Add_Ball(0,2,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13044170144189109E+002);
    New_Polymer(2);
    Add_Ball(0,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15175750203935128E+002);
    New_Polymer(2);
    Add_Ball(0,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16571131496906055E+002);
    New_Polymer(2);
    Add_Ball(0,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16557245390483535E+002);
    New_Polymer(2);
    Add_Ball(0,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17410894216486067E+002);
    New_Polymer(2);
    Add_Ball(0,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14309076266540685E+002);
    New_Polymer(2);
    Add_Ball(0,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15398739739192003E+002);
    New_Polymer(2);
    Add_Ball(0,6,0);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14103547520391392E+002);
    New_Polymer(2);
    Add_Ball(0,6,0);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15608476875144635E+002);
    New_Polymer(2);
    Add_Ball(0,6,0);
    Add_Ball(-1,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.12814934414137295E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(0,0,2);
    Add_Ball(2,-1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16021140107021710E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14683883712970840E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(1,0,3);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.10564619917487843E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(1,0,3);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11749979229500952E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(1,0,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16166293193703112E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(1,0,3);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15341862062336915E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(1,1,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17544409765191174E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11439301698900940E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12242622993503211E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.07934362295123200E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10890868145932475E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15497621985501377E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16732656644297951E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16318174245428425E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.06781382432228462E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10177035653589160E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15563844367650446E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14683883712970753E+002);
    New_Polymer(2);
    Add_Ball(-1,1,3);
    Add_Ball(-3,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16318174245424767E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(-1,-2,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15586697177886102E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(1,-3,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15586697177886102E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(2,-2,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17140699659064157E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,2,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17077065211004010E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12355878281854070E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08153500526767144E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.17807974153940905E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09148745733726045E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(2,-2,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17948846573179093E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(3,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16492507498677853E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.03882486447699981E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.04256322903020519E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.06742630482309945E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11887408470714591E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(1,-2,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15923465400880864E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(1,-2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09760896838548558E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-2,0,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17140699659064157E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(2,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16492507498677853E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(2,-1,2);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16403172693784271E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(2,-1,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11727362878589324E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(2,-1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10927764477033915E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16224548492928674E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17141927342751418E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.07128310723278523E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.16173967222688629E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11196574491590659E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.06033743354537213E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10399240000021821E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(2,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.10869336603583865E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(2,1,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11437312761235717E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11621007017155415E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14180230850448194E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09790310864047634E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08354987873788418E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12266388859410548E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11977640734646624E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.06010492816336740E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.16663664758145614E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16054963024121328E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-2,1,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15900944369946790E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10616557855905813E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-2,3,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15992477570334363E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11437978494786488E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.16173967222688629E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16050387453574466E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,-2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.09937572850240106E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16908256017950692E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(1,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10237949656087672E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16373558334732846E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12155361835339449E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11328003890160462E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10961413202348784E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.03293592165794640E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17501317951534238E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(2,-1,2);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16124480681131094E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.06727373885172660E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.06887659069568212E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(2,-1,2);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10764053635782251E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.05675853235136670E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.06349266301396734E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16994489205112263E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13486564780506581E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.04412244790976887E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.05776711975622127E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.07633344295502801E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10868647267889957E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09025273080663948E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.09464415024747832E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-4,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15198939824936844E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09302136291044703E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10606280652565328E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-4,4,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15195300105587410E+002);
    New_Polymer(2);
    Add_Ball(-1,2,2);
    Add_Ball(-5,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13822236308032245E+002);
    New_Polymer(2);
    Add_Ball(-1,2,4);
    Add_Ball(0,2,3);
    Add_Ball(1,1,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.13044170144188686E+002);
    New_Polymer(2);
    Add_Ball(-1,2,4);
    Add_Ball(0,2,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14361433517948320E+002);
    New_Polymer(2);
    Add_Ball(-1,2,4);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15749790048827226E+002);
    New_Polymer(2);
    Add_Ball(-1,2,4);
    Add_Ball(-1,1,3);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14508592491284346E+002);
    New_Polymer(2);
    Add_Ball(-1,2,4);
    Add_Ball(-2,3,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14361433517948445E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(0,-1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17502521265301042E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11236505686948683E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11553503893571107E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10744382267219882E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(2,-2,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13898791282319847E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(-2,4,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.16232507490959168E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(3,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14601068556864540E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12580463111090015E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12748883604234312E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09032724812471567E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09036537214506384E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-1,5,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16648782160065879E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15323547709236395E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,4,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17495534677595575E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(2,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08889345911295439E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(2,1,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16067518239916765E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(2,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16828154962759536E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15983135845421443E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(1,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09478002773957039E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(1,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11374427750526328E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(1,3,1);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12594890692382967E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(1,3,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15699981887649753E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(1,3,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16667545316999402E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(1,3,1);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15398739739192003E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,-1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16662564235234328E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13422018778386271E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14665335815014448E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08489776604237237E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10930368002089311E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11269498261183798E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(1,0,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17506968215727083E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10433687718734849E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16651171671382941E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11743593424411023E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16571131496906055E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08604091173605738E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-1,5,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15793908049819125E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15880140768510192E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,4,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11832681393832578E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-3,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16073855277178463E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,5,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16759262158965178E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.07139190759097354E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12117183856248795E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15545909839181438E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12135242006465652E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15127429838490405E+002);
    New_Polymer(2);
    Add_Ball(-1,4,1);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15992864245420500E+002);
    New_Polymer(2);
    Add_Ball(-1,4,3);
    Add_Ball(0,2,3);
    Add_Ball(1,1,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13926216259835475E+002);
    New_Polymer(2);
    Add_Ball(-1,4,3);
    Add_Ball(0,2,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14871322154736046E+002);
    New_Polymer(2);
    Add_Ball(-1,4,3);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15818033297910495E+002);
    New_Polymer(2);
    Add_Ball(-1,4,3);
    Add_Ball(-2,3,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14871322154735886E+002);
    New_Polymer(2);
    Add_Ball(-1,4,3);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15818033297910451E+002);
    New_Polymer(2);
    Add_Ball(-1,4,3);
    Add_Ball(-2,4,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14957796909556839E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.06357201210514862E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(2,2,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.10675013099867175E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(2,2,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15037129048285002E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15030408987491071E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(1,4,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.12289356814123323E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(1,4,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14218350980423037E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(0,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.08370797552534500E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.06408940485703804E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.12290099286568820E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.08372794323929185E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.06733110639800948E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(-3,3,0);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14206968190849329E+002);
    New_Polymer(2);
    Add_Ball(-1,5,0);
    Add_Ball(-4,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.13530936684339656E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16662954505995397E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15743402591203764E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16662954505995396E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15743402591203765E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(0,3,2);
    Add_Ball(1,1,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13467741376170919E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14864069165035131E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15271210733042735E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16662564235234328E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16648782160065869E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17502521265301063E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14866835678841581E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15901619611564571E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15793908049819125E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16759262158965268E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14634577174033749E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14864069165035129E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-2,4,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15808271553144839E+002);
    New_Polymer(2);
    Add_Ball(-1,5,2);
    Add_Ball(-2,4,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14806212062646366E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(0,-1,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16759262158965276E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(0,-1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12684306007852353E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08527236712929412E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12577580679856248E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16913528489649633E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08308806639627835E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.07422712220687475E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(2,-2,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15328239451448407E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(3,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15979436765224814E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.05135485396248056E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10858573901456663E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.04336069372890650E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.05390811392148982E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.01369848489221613E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09066432600243567E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.06973861568370380E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,4,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.10776193042892670E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.06364985386813101E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(2,1,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08899092646959738E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(2,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10949094191056900E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-2,4,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17506968215727354E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.07330598701846713E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-3,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16559783595400894E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08138788365708953E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12863324819976549E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-3,2,1);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16667545316999402E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-3,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16662564235234328E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08199565581387893E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.02979245029242749E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(1,-3,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.08630118869135586E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(2,-2,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10712865906015198E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.03231820182352399E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.04458880345769857E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11589739915888248E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(2,-2,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12020020631250193E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(3,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09983562023168149E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08583309252587702E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(2,1,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.11286239148726773E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08385543393258561E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,4,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.13423780215150897E+002);
    New_Polymer(2);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(-3,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.10328614137413102E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(0,2,3);
    Add_Ball(1,1,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13926216259835655E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(0,2,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09149733890921408E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14086663601227023E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-1,1,3);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15240353747766386E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-1,1,3);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15240353747766224E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-1,1,3);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16581522595212928E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-1,1,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10404024506363132E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-1,1,3);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16166293193704877E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10023828190114391E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14270511540787279E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09644862713631686E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10067945060385156E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-2,4,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16224548492928756E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-3,2,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14871322154736081E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-3,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10979975059091994E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-3,3,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16732656644298069E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-3,3,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17141927342750841E+002);
    New_Polymer(2);
    Add_Ball(-2,3,3);
    Add_Ball(-3,3,2);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15992477570334357E+002);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.04783245555232820E+002);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.05151328096436126E+002);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(0,3,0);
    Add_Ball(2,2,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.10848541855570088E+002);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(0,3,0);
    Add_Ball(-3,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15608889699160277E+002);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(0,3,0);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.06195219006142061E+002);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.00916771056317590E+002);
    New_Polymer(2);
    Add_Ball(-2,4,0);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(-4,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.06864025614893084E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(0,0,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15637595102442363E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17506968215727358E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.16663664758145525E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17506968215727356E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(0,3,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16663664758145493E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(0,3,2);
    Add_Ball(1,1,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14866835678841723E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(0,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12838787832370398E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(0,3,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16662564235234328E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(0,3,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15743402591203763E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14736441635614276E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15779602716045827E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,0,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09625530786153574E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.18246803614249373E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12014616801155040E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.17807974153940905E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10991014761956357E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11825168301172668E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15036863520028381E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15901619611564929E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(1,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15155485917520946E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,4,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15818033297910633E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09718108336769335E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.07060598935622663E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11309699965820222E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15136392680221910E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-3,5,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14957796909557156E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.16232507490959168E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17495534677595575E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11832681393833645E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-2,1,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15289371726885755E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.10776193042892635E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.13423780215150862E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-3,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.09749822346491949E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-3,3,2);
    Add_Ball(-2,1,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15900944369946753E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-3,3,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12684306007852289E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-3,3,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10100132661134737E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-3,3,2);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16759262158965248E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-3,3,2);
    Add_Ball(-3,2,1);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14806212062646602E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10526577371784834E+002);
    New_Polymer(2);
    Add_Ball(-2,4,2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15970935504388597E+002);
    New_Polymer(2);
    Add_Ball(-2,4,4);
    Add_Ball(-2,3,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.13044170144189026E+002);
    New_Polymer(2);
    Add_Ball(-2,6,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13740839313470995E+002);
    New_Polymer(2);
    Add_Ball(-2,6,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15171119337044227E+002);
    New_Polymer(2);
    Add_Ball(-2,6,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16138348872502850E+002);
    New_Polymer(2);
    Add_Ball(-2,6,1);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15702636330669231E+002);
    New_Polymer(2);
    Add_Ball(-2,6,1);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16667995468262189E+002);
    New_Polymer(2);
    Add_Ball(-2,6,1);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14193404358454966E+002);
    New_Polymer(2);
    Add_Ball(-2,6,1);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15717105386137103E+002);
    New_Polymer(2);
    Add_Ball(-2,6,1);
    Add_Ball(-3,5,1);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15181282706814253E+002);
    New_Polymer(2);
    Add_Ball(-2,7,0);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.12651061673108792E+002);
    New_Polymer(2);
    Add_Ball(-2,7,0);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14209358634732780E+002);
    New_Polymer(2);
    Add_Ball(-2,7,0);
    Add_Ball(-1,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14215515079083630E+002);
    New_Polymer(2);
    Add_Ball(-2,7,0);
    Add_Ball(-3,6,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.12657236427919411E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15180824997983851E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16568340648789671E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16554709171588409E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.17410565516002265E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15717105386137103E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16667995468262189E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08462994841332393E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10562438412270118E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-1,4,1);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11247412416233363E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,-1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15808271553144839E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16556851346856066E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08687801405184775E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12033991158887996E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(1,0,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16662954505995482E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08921738706271966E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10272974866707861E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.06531194367062389E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14377250421606766E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,4,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10526577371784679E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-3,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15418814289674103E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-3,6,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14288962063818057E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-4,5,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15271210733042735E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11983020676575755E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15992864245420500E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12382779114447590E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13743976527477136E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-4,4,1);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15181282706814253E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-4,4,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15702788659670591E+002);
    New_Polymer(2);
    Add_Ball(-3,5,1);
    Add_Ball(-4,4,1);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16568340648789671E+002);
    New_Polymer(2);
    Add_Ball(-3,5,3);
    Add_Ball(-2,3,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13926216259835590E+002);
    New_Polymer(2);
    Add_Ball(-3,5,3);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14957796909557155E+002);
    New_Polymer(2);
    Add_Ball(-3,6,0);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(1,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.14097876747276161E+002);
    New_Polymer(2);
    Add_Ball(-3,6,0);
    Add_Ball(-1,5,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15611562492661806E+002);
    New_Polymer(2);
    Add_Ball(-3,6,0);
    Add_Ball(-1,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.10759380776366177E+002);
    New_Polymer(2);
    Add_Ball(-3,6,0);
    Add_Ball(-2,4,0);
    Add_Ball(0,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.10499323670585301E+002);
    New_Polymer(2);
    Add_Ball(-3,6,0);
    Add_Ball(-2,4,0);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.06566560056450506E+002);
    New_Polymer(2);
    Add_Ball(-3,6,0);
    Add_Ball(-4,5,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.06877085977827062E+002);
    New_Polymer(2);
    Add_Ball(-3,6,0);
    Add_Ball(-4,5,0);
    Add_Ball(-3,3,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.15605848214630267E+002);
    New_Polymer(2);
    Add_Ball(-3,6,0);
    Add_Ball(-4,5,0);
    Add_Ball(-3,3,0);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.14109200574409315E+002);
    New_Polymer(2);
    Add_Ball(-3,6,2);
    Add_Ball(-2,4,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13467741376170919E+002);
    New_Polymer(2);
    Add_Ball(-3,6,2);
    Add_Ball(-2,4,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15808271553144839E+002);
    New_Polymer(2);
    Add_Ball(-3,6,2);
    Add_Ball(-2,4,2);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14806212062646522E+002);
    New_Polymer(2);
    Add_Ball(-3,6,2);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.14288962063818057E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,-1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15808271553144839E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15165533908958319E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.08783925083966597E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(0,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10832070178546463E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(1,0,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.16662954505995370E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,-1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10435150333787589E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(1,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.11737628104984991E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.07795776205644166E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,0,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15873830918622883E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,1,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12591763038750926E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-2,4,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15970935504388597E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(-3,3,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12669980301665612E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(6);
    Add_Value( 2.07787536415853608E+002);
    New_Polymer(2);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.10562438414345614E+002);
    New_Polymer(2);
    Add_Ball(-4,4,3);
    Add_Ball(-2,3,3);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.13926216259835642E+002);
    New_Polymer(2);
    Add_Ball(-4,4,3);
    Add_Ball(-3,3,2);
    Add_Ball(-1,2,2);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15992477570334397E+002);
    New_Polymer(2);
    Add_Ball(-4,7,1);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.12746367317245134E+002);
    New_Polymer(2);
    Add_Ball(-4,7,1);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14319607977771281E+002);
    New_Polymer(2);
    Add_Ball(-4,8,0);
    Add_Ball(-3,6,0);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(3);
    Add_Value( 2.11202301548549107E+002);
    New_Polymer(2);
    Add_Ball(-5,6,1);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14199062614171555E+002);
    New_Polymer(2);
    Add_Ball(-5,6,1);
    Add_Ball(-3,5,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15714192756813385E+002);
    New_Polymer(2);
    Add_Ball(-5,6,1);
    Add_Ball(-3,5,1);
    Add_Ball(-2,4,0);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14319607977771281E+002);
    New_Polymer(2);
    Add_Ball(-5,6,1);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15699721499912127E+002);
    New_Polymer(2);
    Add_Ball(-5,6,1);
    Add_Ball(-4,4,1);
    Add_Ball(-2,3,1);
    Add_Ball(-1,2,0);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.15714192756813385E+002);
    New_Polymer(2);
    Add_Ball(-5,6,1);
    Add_Ball(-4,4,1);
    Add_Ball(-3,2,1);
    Add_Ball(-1,1,1);
    Add_Ball(0,0,0);
    Add_Multiplicity(12);
    Add_Value( 2.14300252248554195E+002);
  end VolumesHCP5;

end Volumes;
